/*
    Copyright (C) 2019 Minibot
    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in
      the documentation and/or other materials provided with the 
      distribution.
    * Neither the name of Minibot nor the names
      of its contributors may be used to endorse or promote products
      derived from this software without specific prior written
      permission.
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
    FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
    COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
    INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
    BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
    OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
    AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
*/

#include "NanopixCore.h"

using namespace NanopixCore;

MainController & nanopix = MainController::getInstance();

void setup() {}

// ------------------------------------- flightScript ---------------------------------------------
// ------- English: Write your own program for Nanopix inside the flightScript() function.
// ------- In this example LEDs brightness depends on distance (elevation) sensor value.
// ------------------------------------------------------------------------------------------------
// ------- Russian: Напишите свою программу для Nanopix внутри функции flightScript().
// ------- В текущем примере яркость светодиодов регулируется дистанцией, которую измеряет 
// ------- датчик расстояния. Держа в руках дрон, попробуйте поднять и опустить его над ровной поверхностью.
// ------------------------------------------------------------------------------------------------
void flightScript() 
{
  while(true)
  {
    // English: get quadcopter elevation in centimeters
    // Russian: возвращает текущую высоту аппарата над поверхностью
    int altitudeCm = nanopix.getAltitudeCentimeters();

    // English: set LEDs channel brightness based on scaled elevation value
    // Russian: устанавлием значение яркости свечения каналов R переднего 
    //          светодиода и B заднего светодиода на основе высоты аппарата
	  nanopix.setLEDsColors(altitudeCm * 2, 0, 0, 0, altitudeCm * 2, 0);
    delay(100);
  }
  // English: you can disable used telemetry stream after this script
  // Russian: вы можете выключить телеметрию положения после завершения вашего скрипта
  nanopix.requestTelemetryDataStream(MainController::LocalPosition, 0, false); 
}

void loop() {
  nanopix.mainRoutine();

  if(nanopix.isMissionTriggered())
  {
    delay(1000);
    flightScript();
    nanopix.isArmCommandReceived();
	  nanopix.resetMissionTrigger();
  }
}

