/*
    Copyright (C) 2019 Minibot
    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in
      the documentation and/or other materials provided with the 
      distribution.
    * Neither the name of Minibot nor the names
      of its contributors may be used to endorse or promote products
      derived from this software without specific prior written
      permission.
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
    FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
    COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
    INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
    BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
    OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
    AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
*/

#include "NanopixCore.h"

using namespace NanopixCore;

MainController & nanopix = MainController::getInstance();

void setup() {}

// ------------------------------------- flightScript ---------------------------------------------
// ------- English: Write your own program for Nanopix inside the flightScript() function.
// ------- In this example Nanopix will takeoff to 60 cm elevation, stay 4 seconds, next do landing.
// ------------------------------------------------------------------------------------------------
// ------- Russian: Напишите свою программу для Nanopix внутри функции flightScript().
// ------- В текущем примере дрон автоматически взлетает на высоту 60 сантиметров, удерживает 
// ------- высоту 4 секунды и затем совершает снижение до полной посадки. 
// ------- Для версий без оптической стабилизации (< V8) удерживайте горизонт вручную.
// ------------------------------------------------------------------------------------------------
void flightScript() 
{
	int meters = 0;

	nanopix.setLEDsColors(Color::Blue, Color::Blue);

  // English: start quadcopter engines
  // Russian: запускаем двигатели
	nanopix.armMotors(); 

  // English: 4 second takeoff
  // Russian: плавный взлет 4 секунды
	for(int i = 0; i < 20; i++)
	{
		meters += 0.03f;
		nanopix.setTargetAltitude(meters);
		delay(200);
	}

  // English: stay and blink leds within 4 seconds
  // Russian: моргаем светодиодами при удержании высоты 4 секунды
	for(int i = 0; i < 20; i++)
	{
		nanopix.setLEDsColors(Color::Disable, Color::Disable);
		delay(100);
		nanopix.setLEDsColors(Color::Purple, Color::Purple);
		delay(100);
	}

  // English: 4 second land
  // Russian: плавная посадка 4 секунды
	for(int i = 0; i < 20; i++)
	{
		meters -= 0.03f;
		nanopix.setTargetAltitude(meters);
		delay(200);
	}

  // English: stop engines
  // Russian: останавливаем двигатели
	nanopix.disarmMotors();
}

void loop() {
  nanopix.mainRoutine();

  if(nanopix.isMissionTriggered())
  {
    delay(1000);
    flightScript();
    nanopix.isArmCommandReceived();
	  nanopix.resetMissionTrigger();
  }
}

