/*
    Copyright (C) 2019 Minibot
    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in
      the documentation and/or other materials provided with the 
      distribution.
    * Neither the name of Minibot nor the names
      of its contributors may be used to endorse or promote products
      derived from this software without specific prior written
      permission.
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
    FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
    COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
    INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
    BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
    OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
    AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
*/

#include "NanopixCore.h"

using namespace NanopixCore; 

MainController & nanopix = MainController::getInstance();

void setup() { }

// ------------------------------------- flightScript ---------------------------------------------
// ------- English: Write your own program for Nanopix inside the flightScript() function.
// ------- In this example LEDs colors controlled by right stick (on App, Ground Station or Nanopad).
// ------------------------------------------------------------------------------------------------
// ------- Russian: Напишите свою программу для Nanopix внутри функции flightScript().
// ------- В текущем примере цвет светодиодов регулируется правым джойстиком. Запустите приложение,
// ------- запустите скрипт и подвигайте правым джойстиком.
// ------------------------------------------------------------------------------------------------
void flightScript()
{
  while(true)
  {
    // English: get right stick horizontal value (roll), range is [1000..2000]. Center ~ 1500 value.
    // Russian: значения правого джойстика по горизонтали [1000..2000], 1500 в центре
    int rcRoll = nanopix.getRC_Roll(); 

    // English: get right stick vertical value (pitch), range is [1000..2000]. Center ~ 1500 value.
    // Russian: значения правого джойстика по вертикали [1000..2000], 1500 в центре
    int rcPitch = nanopix.getRC_Pitch(); 

    // English: convert pitch/roll sticks values to LEDs colors
    // Russian: конвертируем значения отклонения правого стика в цвет светодиодов
    int fColorComponent = abs((rcRoll - 1500) / 2);
    int bColorComponent = abs((rcPitch - 1500) / 2);

    Color fc(fColorComponent, 0, 0);
    Color bc(0, 0, bColorComponent);
    nanopix.setLEDsColors(fc, bc);
    delay(50);
  }
}
// ------------------------------------------------------------------------------------------------

void loop() {
  nanopix.mainRoutine();
  
  if(nanopix.isMissionTriggered())
  {
    delay(1000);
    flightScript();
    nanopix.isArmCommandReceived();
	  nanopix.resetMissionTrigger();
  }
}