/*
    Copyright (C) 2019 Minibot
    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in
      the documentation and/or other materials provided with the 
      distribution.
    * Neither the name of Minibot nor the names
      of its contributors may be used to endorse or promote products
      derived from this software without specific prior written
      permission.
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
    FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
    COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
    INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
    BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
    OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
    AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
*/

#include "NanopixCore.h"

using namespace NanopixCore; 

MainController & nanopix = MainController::getInstance();

void setup() { }

// ------------------------------------- flightScript ---------------------------------------------
// ------- English: Write your own program for Nanopix inside the flightScript() function.
// ------- In this example Nanopix will takeoff to 60 cm elevation, stay 3 seconds, next do landing.
// ------------------------------------------------------------------------------------------------
// ------- Russian: Напишите свою программу для Nanopix внутри функции flightScript().
// ------- В текущем примере дрон автоматически взлетает, 3 секунды удерживает высоту и затем
// ------- снижается до полной посадки. Для версии дрона младше V8 рекомендуется с пульта управлять
// ------- наклоном дрона в процессе работы данного скрипта.
// ------------------------------------------------------------------------------------------------
void flightScript()
{
  // English: Automatic takeoff up to 60 cm altitude. Blocked function.
  // Russian: Осуществляет взлёт на высоту 60 см. Блокирующая функция.
  nanopix.takeoff();

  delay(3000);
  
  // English: Automatic landing and disarm. Blocked function.
  // Russian: Осуществляет плавную посадку и выключение двигателей. Блокирующая функция.
  nanopix.land();
}
// ------------------------------------------------------------------------------------------------

void loop() {
  nanopix.mainRoutine();
  
  if(nanopix.isMissionTriggered())
  {
    delay(1000);
    flightScript();
    nanopix.isArmCommandReceived();
	  nanopix.resetMissionTrigger();
  }
}

