/*
    Copyright (C) 2019 Minibot
    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in
      the documentation and/or other materials provided with the 
      distribution.
    * Neither the name of Minibot nor the names
      of its contributors may be used to endorse or promote products
      derived from this software without specific prior written
      permission.
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
    FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
    COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
    INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
    BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
    OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
    AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
*/

#include "NanopixCore.h"

using namespace NanopixCore; 

MainController & nanopix = MainController::getInstance();

void setup() { }

// ------------------------------------- flightScript ---------------------------------------------
// ------- English: Write your own program for Nanopix inside the flightScript() function.
// ------- In this example Nanopix takeoff up to 60 cm, next increase altitude up to 130 cm with 5 cm step.
// ------- Print current altitude to log within movement.
// ------------------------------------------------------------------------------------------------
// ------- Russian: В текущем примере дрон взлетает до высоты 60 см, затем поднимается до 130 см и каждые
// ------- 5 см печатает в консоль текущую высоту в сантиметрах
// ------------------------------------------------------------------------------------------------
void flightScript()
{
  // English: Takeoff up to 60 cm. Blocked function.
  // Russian: Автовзлет до высоты 60 сантиметров.
  nanopix.takeoff();

  // English: Increase altitude with 5 cm step, log current altitude to GS.
	// Russian: Увеличиваем высоту по 5 см до высоты 130 сантиметров, 
  // каждую итерацию печатаем текущую высоту в консоль.
	while(nanopix.getAltitudeCentimeters() < 130)
	{
		nanopix.sendLogMsg(nanopix.getAltitudeCentimeters());

    // English: Increase current altitude by 5 cm. Blocked function, will wait the movement finish.
    // Russian: Увеличиваем высоту на 5 сантиметров от текущей (с ожиданием завершения).
		nanopix.offsetTargetAltitude(0.05f); 
	}
  
  // English: Automatic landing and disarm at finish.
  // Russian: Посадка с выключением двигателей по завершении.
  nanopix.land();
}
// ------------------------------------------------------------------------------------------------

void loop() {
  nanopix.mainRoutine();
  
  if(nanopix.isMissionTriggered())
  {
    delay(1000);
    flightScript();
	  nanopix.resetMissionTrigger();
  }
}
