/*
    Copyright (C) 2019 Minibot
    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in
      the documentation and/or other materials provided with the 
      distribution.
    * Neither the name of Minibot nor the names
      of its contributors may be used to endorse or promote products
      derived from this software without specific prior written
      permission.
    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
    FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
    COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
    INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
    BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
    OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
    AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
*/

#include "NanopixCore.h"

using namespace NanopixCore; 

MainController & nanopix = MainController::getInstance();

void setup() { }

// ------------------------------------- flightScript ---------------------------------------------
// ------- English: Write your own program for Nanopix inside the flightScript() function.
// ------- In this example Nanopix takeoff, rotates 90 degrees clockwise, next rotates back to initial yaw, 
// ------- next land.
// ------------------------------------------------------------------------------------------------
// ------- Russian: В текущем примере дрон взлетает, поворачивается на 90 градусов по часовой стрелке, затем 
// ------- поворачивается в исходное положение и совершает посадку.
// ------------------------------------------------------------------------------------------------
void flightScript()
{
   // English: 1. Automatic takeoff up to 60 cm. Blocking function.
   // Russian: 1. Автовзлет, по умолчанию эта функция выполняется до того момента как дрон поднимется 
   // и зафиксирует высоту.
   nanopix.takeoff();

   // English: 2. Rotate by 90 degrees clockwise (CW).
   // Russian: 2. Поворот по углу рысканья на 90 градусов по часовой стрелке.
   nanopix.rotateYawDegrees(90);

   // English: 3. Rotate by 90 degrees counterclockwise (CCW).
   // Russian: 3. Поворот по углу рысканья на 90 градусов против часовой стрелки.
   nanopix.rotateYawDegrees(-90);

   // English: 4. Automatic landing.
   // Russian: 4. Автоматическая посадка.
   nanopix.land();
}
// ------------------------------------------------------------------------------------------------

void loop() {
  nanopix.mainRoutine();
  
  if(nanopix.isMissionTriggered())
  {
    delay(1000);
    flightScript();
    nanopix.resetMissionTrigger();
  }
}
