// MESSAGE RAW_6AXIS_IMU PACKING

#define MAVLINK_MSG_ID_RAW_6AXIS_IMU 195

MAVPACKED(
typedef struct __mavlink_raw_6axis_imu_t {
 uint32_t time_usec; /*< Timestamp (microseconds since UNIX epoch or microseconds since system boot)*/
 int16_t xacc; /*< X acceleration (raw)*/
 int16_t yacc; /*< Y acceleration (raw)*/
 int16_t zacc; /*< Z acceleration (raw)*/
 int16_t xgyro; /*< Angular speed around X axis (raw)*/
 int16_t ygyro; /*< Angular speed around Y axis (raw)*/
 int16_t zgyro; /*< Angular speed around Z axis (raw)*/
}) mavlink_raw_6axis_imu_t;

#define MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN 16
#define MAVLINK_MSG_ID_RAW_6AXIS_IMU_MIN_LEN 16
#define MAVLINK_MSG_ID_195_LEN 16
#define MAVLINK_MSG_ID_195_MIN_LEN 16

#define MAVLINK_MSG_ID_RAW_6AXIS_IMU_CRC 162
#define MAVLINK_MSG_ID_195_CRC 162



#if MAVLINK_COMMAND_24BIT
#define MAVLINK_MESSAGE_INFO_RAW_6AXIS_IMU { \
	195, \
	"RAW_6AXIS_IMU", \
	7, \
	{  { "time_usec", NULL, MAVLINK_TYPE_UINT32_T, 0, 0, offsetof(mavlink_raw_6axis_imu_t, time_usec) }, \
         { "xacc", NULL, MAVLINK_TYPE_INT16_T, 0, 4, offsetof(mavlink_raw_6axis_imu_t, xacc) }, \
         { "yacc", NULL, MAVLINK_TYPE_INT16_T, 0, 6, offsetof(mavlink_raw_6axis_imu_t, yacc) }, \
         { "zacc", NULL, MAVLINK_TYPE_INT16_T, 0, 8, offsetof(mavlink_raw_6axis_imu_t, zacc) }, \
         { "xgyro", NULL, MAVLINK_TYPE_INT16_T, 0, 10, offsetof(mavlink_raw_6axis_imu_t, xgyro) }, \
         { "ygyro", NULL, MAVLINK_TYPE_INT16_T, 0, 12, offsetof(mavlink_raw_6axis_imu_t, ygyro) }, \
         { "zgyro", NULL, MAVLINK_TYPE_INT16_T, 0, 14, offsetof(mavlink_raw_6axis_imu_t, zgyro) }, \
         } \
}
#else
#define MAVLINK_MESSAGE_INFO_RAW_6AXIS_IMU { \
	"RAW_6AXIS_IMU", \
	7, \
	{  { "time_usec", NULL, MAVLINK_TYPE_UINT32_T, 0, 0, offsetof(mavlink_raw_6axis_imu_t, time_usec) }, \
         { "xacc", NULL, MAVLINK_TYPE_INT16_T, 0, 4, offsetof(mavlink_raw_6axis_imu_t, xacc) }, \
         { "yacc", NULL, MAVLINK_TYPE_INT16_T, 0, 6, offsetof(mavlink_raw_6axis_imu_t, yacc) }, \
         { "zacc", NULL, MAVLINK_TYPE_INT16_T, 0, 8, offsetof(mavlink_raw_6axis_imu_t, zacc) }, \
         { "xgyro", NULL, MAVLINK_TYPE_INT16_T, 0, 10, offsetof(mavlink_raw_6axis_imu_t, xgyro) }, \
         { "ygyro", NULL, MAVLINK_TYPE_INT16_T, 0, 12, offsetof(mavlink_raw_6axis_imu_t, ygyro) }, \
         { "zgyro", NULL, MAVLINK_TYPE_INT16_T, 0, 14, offsetof(mavlink_raw_6axis_imu_t, zgyro) }, \
         } \
}
#endif

/**
 * @brief Pack a raw_6axis_imu message
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param msg The MAVLink message to compress the data into
 *
 * @param time_usec Timestamp (microseconds since UNIX epoch or microseconds since system boot)
 * @param xacc X acceleration (raw)
 * @param yacc Y acceleration (raw)
 * @param zacc Z acceleration (raw)
 * @param xgyro Angular speed around X axis (raw)
 * @param ygyro Angular speed around Y axis (raw)
 * @param zgyro Angular speed around Z axis (raw)
 * @return length of the message in bytes (excluding serial stream start sign)
 */
static inline uint16_t mavlink_msg_raw_6axis_imu_pack(uint8_t system_id, uint8_t component_id, mavlink_message_t* msg,
						       uint32_t time_usec, int16_t xacc, int16_t yacc, int16_t zacc, int16_t xgyro, int16_t ygyro, int16_t zgyro)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
	char buf[MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN];
	_mav_put_uint32_t(buf, 0, time_usec);
	_mav_put_int16_t(buf, 4, xacc);
	_mav_put_int16_t(buf, 6, yacc);
	_mav_put_int16_t(buf, 8, zacc);
	_mav_put_int16_t(buf, 10, xgyro);
	_mav_put_int16_t(buf, 12, ygyro);
	_mav_put_int16_t(buf, 14, zgyro);

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), buf, MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN);
#else
	mavlink_raw_6axis_imu_t packet;
	packet.time_usec = time_usec;
	packet.xacc = xacc;
	packet.yacc = yacc;
	packet.zacc = zacc;
	packet.xgyro = xgyro;
	packet.ygyro = ygyro;
	packet.zgyro = zgyro;

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), &packet, MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN);
#endif

	msg->msgid = MAVLINK_MSG_ID_RAW_6AXIS_IMU;
    return mavlink_finalize_message(msg, system_id, component_id, MAVLINK_MSG_ID_RAW_6AXIS_IMU_MIN_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_CRC);
}

/**
 * @brief Pack a raw_6axis_imu message on a channel
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param chan The MAVLink channel this message will be sent over
 * @param msg The MAVLink message to compress the data into
 * @param time_usec Timestamp (microseconds since UNIX epoch or microseconds since system boot)
 * @param xacc X acceleration (raw)
 * @param yacc Y acceleration (raw)
 * @param zacc Z acceleration (raw)
 * @param xgyro Angular speed around X axis (raw)
 * @param ygyro Angular speed around Y axis (raw)
 * @param zgyro Angular speed around Z axis (raw)
 * @return length of the message in bytes (excluding serial stream start sign)
 */
static inline uint16_t mavlink_msg_raw_6axis_imu_pack_chan(uint8_t system_id, uint8_t component_id, uint8_t chan,
							   mavlink_message_t* msg,
						           uint32_t time_usec,int16_t xacc,int16_t yacc,int16_t zacc,int16_t xgyro,int16_t ygyro,int16_t zgyro)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
	char buf[MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN];
	_mav_put_uint32_t(buf, 0, time_usec);
	_mav_put_int16_t(buf, 4, xacc);
	_mav_put_int16_t(buf, 6, yacc);
	_mav_put_int16_t(buf, 8, zacc);
	_mav_put_int16_t(buf, 10, xgyro);
	_mav_put_int16_t(buf, 12, ygyro);
	_mav_put_int16_t(buf, 14, zgyro);

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), buf, MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN);
#else
	mavlink_raw_6axis_imu_t packet;
	packet.time_usec = time_usec;
	packet.xacc = xacc;
	packet.yacc = yacc;
	packet.zacc = zacc;
	packet.xgyro = xgyro;
	packet.ygyro = ygyro;
	packet.zgyro = zgyro;

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), &packet, MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN);
#endif

	msg->msgid = MAVLINK_MSG_ID_RAW_6AXIS_IMU;
    return mavlink_finalize_message_chan(msg, system_id, component_id, chan, MAVLINK_MSG_ID_RAW_6AXIS_IMU_MIN_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_CRC);
}

/**
 * @brief Encode a raw_6axis_imu struct
 *
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param msg The MAVLink message to compress the data into
 * @param raw_6axis_imu C-struct to read the message contents from
 */
static inline uint16_t mavlink_msg_raw_6axis_imu_encode(uint8_t system_id, uint8_t component_id, mavlink_message_t* msg, const mavlink_raw_6axis_imu_t* raw_6axis_imu)
{
	return mavlink_msg_raw_6axis_imu_pack(system_id, component_id, msg, raw_6axis_imu->time_usec, raw_6axis_imu->xacc, raw_6axis_imu->yacc, raw_6axis_imu->zacc, raw_6axis_imu->xgyro, raw_6axis_imu->ygyro, raw_6axis_imu->zgyro);
}

/**
 * @brief Encode a raw_6axis_imu struct on a channel
 *
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param chan The MAVLink channel this message will be sent over
 * @param msg The MAVLink message to compress the data into
 * @param raw_6axis_imu C-struct to read the message contents from
 */
static inline uint16_t mavlink_msg_raw_6axis_imu_encode_chan(uint8_t system_id, uint8_t component_id, uint8_t chan, mavlink_message_t* msg, const mavlink_raw_6axis_imu_t* raw_6axis_imu)
{
	return mavlink_msg_raw_6axis_imu_pack_chan(system_id, component_id, chan, msg, raw_6axis_imu->time_usec, raw_6axis_imu->xacc, raw_6axis_imu->yacc, raw_6axis_imu->zacc, raw_6axis_imu->xgyro, raw_6axis_imu->ygyro, raw_6axis_imu->zgyro);
}

/**
 * @brief Send a raw_6axis_imu message
 * @param chan MAVLink channel to send the message
 *
 * @param time_usec Timestamp (microseconds since UNIX epoch or microseconds since system boot)
 * @param xacc X acceleration (raw)
 * @param yacc Y acceleration (raw)
 * @param zacc Z acceleration (raw)
 * @param xgyro Angular speed around X axis (raw)
 * @param ygyro Angular speed around Y axis (raw)
 * @param zgyro Angular speed around Z axis (raw)
 */
#ifdef MAVLINK_USE_CONVENIENCE_FUNCTIONS

static inline void mavlink_msg_raw_6axis_imu_send(mavlink_channel_t chan, uint32_t time_usec, int16_t xacc, int16_t yacc, int16_t zacc, int16_t xgyro, int16_t ygyro, int16_t zgyro)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
	char buf[MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN];
	_mav_put_uint32_t(buf, 0, time_usec);
	_mav_put_int16_t(buf, 4, xacc);
	_mav_put_int16_t(buf, 6, yacc);
	_mav_put_int16_t(buf, 8, zacc);
	_mav_put_int16_t(buf, 10, xgyro);
	_mav_put_int16_t(buf, 12, ygyro);
	_mav_put_int16_t(buf, 14, zgyro);

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_RAW_6AXIS_IMU, buf, MAVLINK_MSG_ID_RAW_6AXIS_IMU_MIN_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_CRC);
#else
	mavlink_raw_6axis_imu_t packet;
	packet.time_usec = time_usec;
	packet.xacc = xacc;
	packet.yacc = yacc;
	packet.zacc = zacc;
	packet.xgyro = xgyro;
	packet.ygyro = ygyro;
	packet.zgyro = zgyro;

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_RAW_6AXIS_IMU, (const char *)&packet, MAVLINK_MSG_ID_RAW_6AXIS_IMU_MIN_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_CRC);
#endif
}

/**
 * @brief Send a raw_6axis_imu message
 * @param chan MAVLink channel to send the message
 * @param struct The MAVLink struct to serialize
 */
static inline void mavlink_msg_raw_6axis_imu_send_struct(mavlink_channel_t chan, const mavlink_raw_6axis_imu_t* raw_6axis_imu)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    mavlink_msg_raw_6axis_imu_send(chan, raw_6axis_imu->time_usec, raw_6axis_imu->xacc, raw_6axis_imu->yacc, raw_6axis_imu->zacc, raw_6axis_imu->xgyro, raw_6axis_imu->ygyro, raw_6axis_imu->zgyro);
#else
    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_RAW_6AXIS_IMU, (const char *)raw_6axis_imu, MAVLINK_MSG_ID_RAW_6AXIS_IMU_MIN_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_CRC);
#endif
}

#if MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN <= MAVLINK_MAX_PAYLOAD_LEN
/*
  This varient of _send() can be used to save stack space by re-using
  memory from the receive buffer.  The caller provides a
  mavlink_message_t which is the size of a full mavlink message. This
  is usually the receive buffer for the channel, and allows a reply to an
  incoming message with minimum stack space usage.
 */
static inline void mavlink_msg_raw_6axis_imu_send_buf(mavlink_message_t *msgbuf, mavlink_channel_t chan,  uint32_t time_usec, int16_t xacc, int16_t yacc, int16_t zacc, int16_t xgyro, int16_t ygyro, int16_t zgyro)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
	char *buf = (char *)msgbuf;
	_mav_put_uint32_t(buf, 0, time_usec);
	_mav_put_int16_t(buf, 4, xacc);
	_mav_put_int16_t(buf, 6, yacc);
	_mav_put_int16_t(buf, 8, zacc);
	_mav_put_int16_t(buf, 10, xgyro);
	_mav_put_int16_t(buf, 12, ygyro);
	_mav_put_int16_t(buf, 14, zgyro);

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_RAW_6AXIS_IMU, buf, MAVLINK_MSG_ID_RAW_6AXIS_IMU_MIN_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_CRC);
#else
	mavlink_raw_6axis_imu_t *packet = (mavlink_raw_6axis_imu_t *)msgbuf;
	packet->time_usec = time_usec;
	packet->xacc = xacc;
	packet->yacc = yacc;
	packet->zacc = zacc;
	packet->xgyro = xgyro;
	packet->ygyro = ygyro;
	packet->zgyro = zgyro;

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_RAW_6AXIS_IMU, (const char *)packet, MAVLINK_MSG_ID_RAW_6AXIS_IMU_MIN_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN, MAVLINK_MSG_ID_RAW_6AXIS_IMU_CRC);
#endif
}
#endif

#endif

// MESSAGE RAW_6AXIS_IMU UNPACKING


/**
 * @brief Get field time_usec from raw_6axis_imu message
 *
 * @return Timestamp (microseconds since UNIX epoch or microseconds since system boot)
 */
static inline uint32_t mavlink_msg_raw_6axis_imu_get_time_usec(const mavlink_message_t* msg)
{
	return _MAV_RETURN_uint32_t(msg,  0);
}

/**
 * @brief Get field xacc from raw_6axis_imu message
 *
 * @return X acceleration (raw)
 */
static inline int16_t mavlink_msg_raw_6axis_imu_get_xacc(const mavlink_message_t* msg)
{
	return _MAV_RETURN_int16_t(msg,  4);
}

/**
 * @brief Get field yacc from raw_6axis_imu message
 *
 * @return Y acceleration (raw)
 */
static inline int16_t mavlink_msg_raw_6axis_imu_get_yacc(const mavlink_message_t* msg)
{
	return _MAV_RETURN_int16_t(msg,  6);
}

/**
 * @brief Get field zacc from raw_6axis_imu message
 *
 * @return Z acceleration (raw)
 */
static inline int16_t mavlink_msg_raw_6axis_imu_get_zacc(const mavlink_message_t* msg)
{
	return _MAV_RETURN_int16_t(msg,  8);
}

/**
 * @brief Get field xgyro from raw_6axis_imu message
 *
 * @return Angular speed around X axis (raw)
 */
static inline int16_t mavlink_msg_raw_6axis_imu_get_xgyro(const mavlink_message_t* msg)
{
	return _MAV_RETURN_int16_t(msg,  10);
}

/**
 * @brief Get field ygyro from raw_6axis_imu message
 *
 * @return Angular speed around Y axis (raw)
 */
static inline int16_t mavlink_msg_raw_6axis_imu_get_ygyro(const mavlink_message_t* msg)
{
	return _MAV_RETURN_int16_t(msg,  12);
}

/**
 * @brief Get field zgyro from raw_6axis_imu message
 *
 * @return Angular speed around Z axis (raw)
 */
static inline int16_t mavlink_msg_raw_6axis_imu_get_zgyro(const mavlink_message_t* msg)
{
	return _MAV_RETURN_int16_t(msg,  14);
}

/**
 * @brief Decode a raw_6axis_imu message into a struct
 *
 * @param msg The message to decode
 * @param raw_6axis_imu C-struct to decode the message contents into
 */
static inline void mavlink_msg_raw_6axis_imu_decode(const mavlink_message_t* msg, mavlink_raw_6axis_imu_t* raw_6axis_imu)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
	raw_6axis_imu->time_usec = mavlink_msg_raw_6axis_imu_get_time_usec(msg);
	raw_6axis_imu->xacc = mavlink_msg_raw_6axis_imu_get_xacc(msg);
	raw_6axis_imu->yacc = mavlink_msg_raw_6axis_imu_get_yacc(msg);
	raw_6axis_imu->zacc = mavlink_msg_raw_6axis_imu_get_zacc(msg);
	raw_6axis_imu->xgyro = mavlink_msg_raw_6axis_imu_get_xgyro(msg);
	raw_6axis_imu->ygyro = mavlink_msg_raw_6axis_imu_get_ygyro(msg);
	raw_6axis_imu->zgyro = mavlink_msg_raw_6axis_imu_get_zgyro(msg);
#else
        uint8_t len = msg->len < MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN? msg->len : MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN;
        memset(raw_6axis_imu, 0, MAVLINK_MSG_ID_RAW_6AXIS_IMU_LEN);
	memcpy(raw_6axis_imu, _MAV_PAYLOAD(msg), len);
#endif
}
