/*
Copyright (C) 2017 Nanopix
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of Nanopix nor the names
of its contributors may be used to endorse or promote products
derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/

#ifndef NANOPIX_CONFIG
#define NANOPIX_CONFIG
#define MAX_STM_FIRMWARE_SIZE (128000 * 1.2) // 128 KB for STM32F303CBT6 (+20% hex file overhead)
#ifdef ARDUINO_NANOPIX_V7
#define NANOPIX_BOARD_V8_1 (0)
#define MAX_ESP_FIRMWARE_SIZE (512000) // 512 KB for ESP8285
#endif

#ifdef ARDUINO_NANOPIX_V8
#define NANOPIX_BOARD_V8_1 (1)
#define MAX_ESP_FIRMWARE_SIZE (512000) // 512 KB for ESP8285
#endif

#define DEBUG 0
#define TRACE 0

#define DEBUG_MAIN_SERIAL (0)

#define RETRANSMIT_TIMER_FREQ 333 // HZ, retransmit data timer from STM to App/GS
#define FLUSH_STUCK_COMMANDS_HZ 100
#define REPORT_FREQ_HZ (1)

#if NANOPIX_BOARD_V8_1
#define STM32_RESET_GPIO 14
#define STM32_BOOT_GPIO 5
#else
#define STM32_RESET_GPIO 4
#define STM32_BOOT_GPIO 5
#endif


#define NANOPIX_STATUS_OK               0
#define NANOPIX_STATUS_NULL_ARGUMENT    1
#define NANOPIX_STATUS_ALREADY_EXIST    2
#define NANOPIX_STATUS_NO_DATA          3
#define NANOPIX_STATUS_INVALID_ARGUMENT 4
#define NANOPIX_STATUS_FULL             5
#define NANOPIX_STATUS_NO_MEM           6
#define NANOPIX_STATUS_UNSUPP           7
#define NANOPIX_STATUS_UNINITIALIZED    8

#define DEBUG_SERIAL_BAUDRATE 38400
#define DEBUG_SERIAL_TX_PIN 2 // 2 - V8 connector pin

#define UART_BAUDRATE 460800

#define NP_CHECK(x){\
        int macro_opRes = (x);\
        if(macro_opRes != NANOPIX_STATUS_OK){\
            ret = macro_opRes;\
            goto out;\
        }}

#endif

#define LIBRARY_SIGNATURE "9e7d7cf24a62953ef50d8354e78f6575"

#if not DEBUG_MAIN_SERIAL
  #define DEBUG_SW_SERIAL (1)
#else
  #define DEBUG_SW_SERIAL (0)
#endif
