/*
Copyright (C) 2018 Nanopix
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of Nanopix nor the names
of its contributors may be used to endorse or promote products
derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/

#include "stm_boot_manager.h"
#include "Arduino.h"

#include "nanopix_config.h"

namespace NanopixCore
{

void STM_BootManager::toResetState()
{
    pinMode(STM32_RESET_GPIO, OUTPUT);
#if NANOPIX_BOARD_V8_1
    digitalWrite(STM32_RESET_GPIO, INPUT);
#else
    digitalWrite(STM32_RESET_GPIO, LOW);
#endif
}

void STM_BootManager::reset()
{
    pinMode(STM32_RESET_GPIO, OUTPUT);
    digitalWrite(STM32_RESET_GPIO, LOW);
    delay(70);
#if not NANOPIX_BOARD_V8_1
    pinMode(STM32_RESET_GPIO, INPUT_PULLUP);
#endif
    digitalWrite(STM32_RESET_GPIO, HIGH);
}

void STM_BootManager::toBootMode()
{
    pinMode(STM32_BOOT_GPIO, OUTPUT);
    digitalWrite(STM32_BOOT_GPIO, HIGH);
    reset();
    delay(40);
    pinMode(STM32_BOOT_GPIO, INPUT);
    digitalWrite(STM32_BOOT_GPIO, LOW);
}

}